︠4c575ae3-2407-4e02-ab97-5fd1be775a12︠
ttr1 = (0, 0); ttr2 = (0, 1); ttr3 = (1, 1); ttr = (ttr1, ttr2, ttr3)

Polynoms = PolynomialRing(QQ, 'x, y')
(x, y) = Polynoms.gens()
︡24dfbf0a-4c13-4e20-b6e6-bdd106b7dfc3︡︡
︠ab87726c-9711-4873-9299-80c077e1e8bb︠
def S (P, cubatur, (tr1, tr2, tr3)):
    answer = 0;
    for (alpha1, alpha2, alpha3, w) in cubatur:
        answer = answer + (P(alpha1*tr1[0] + alpha2*tr2[0]+alpha3*tr3[0], alpha1*tr1[1] + alpha2*tr2[1]+alpha3*tr3[1]) + P(alpha1*tr1[0] + alpha3*tr2[0]+alpha2*tr3[0], alpha1*tr1[1]+alpha3*tr2[1]+alpha2*tr3[1]) + P(alpha2*tr1[0] + alpha1*tr2[0]+alpha3*tr3[0], alpha2*tr1[1]+alpha1*tr2[1]+alpha3*tr3[1]) + P(alpha3*tr1[0] + alpha1*tr2[0]+alpha2*tr3[0], alpha3*tr1[1]+alpha1*tr2[1]+alpha2*tr3[1]) + P(alpha2*tr1[0] + alpha3*tr2[0]+alpha1*tr3[0], alpha2*tr1[1]+alpha3*tr2[1]+alpha1*tr3[1]) + P(alpha3*tr1[0] + alpha2*tr2[0]+alpha1*tr3[0], alpha3*tr1[1]+alpha2*tr2[1]+alpha1*tr3[1]))*w
    return answer*(-(tr2[0]-tr1[0])*(tr3[1]-tr1[0])+(tr2[1]-tr1[1])*(tr3[0]-tr1[0]))/2
︡78c8ac2b-5f85-40b6-a5ed-eaf0558a3977︡︡
︠7c401ca3-6ab6-4eda-bc26-053c704cdd45︠
def integrr (P, p1, p2):
    pint = integr(P(p1[0] + x*(p2[0]-p1[0]), p1[1] + x*(p2[1]-p1[1]))*(p2[1]-p1[1]))
    if pint == 0:
        return 0
    else:
        return (pint(1,0) - pint(0,0))
︡a4c64200-43eb-4412-bbb7-e64190856e1b︡︡
︠120decdb-63aa-40f8-8934-8f775c91b471︠
def integr (P):
    if P == 0:
        return 0;
    if P.is_monomial():
        return P*x/(P.degree(x)+1)
    else:
        answer = 0
        for monom in P.monomials():
            answer = answer +  P.monomial_coefficient(monom)*monom*x/(monom.degree(x)+1)
        return answer
︡10877d36-5a6c-45c1-98b8-e13ea35c6287︡︡
︠100161a8-ec82-494a-8b00-9a3aa9bdb144︠
def myI (P, (tr1, tr2, tr3)):
    Q = integr(P)
    return integrr (Q, tr2, tr1) + integrr (Q, tr1, tr3) + integrr (Q, tr3, tr2)
︡e0b40713-3719-4105-a683-9f316316b737︡︡
︠cfeaa3c3-800c-4af8-9491-09f311d79924︠
def error (P, cubator, tr):
    return abs(S(P, cubator, tr)-myI(P,tr))
︡f42d7ef5-3654-4218-8755-e05639e5f62a︡︡
︠c77a8edb-fea3-4031-9b2a-dabe29b38e75︠
def split ((tr1, tr2, tr3), ord):
    tr11 = ((tr2[0]+tr3[0])/2, (tr2[1]+tr3[1])/2)
    tr21 = ((tr1[0]+tr3[0])/2, (tr1[1]+tr3[1])/2)
    tr31 = ((tr2[0]+tr1[0])/2, (tr2[1]+tr1[1])/2)
    if ord == 1:
        return ((tr1, tr31, tr21), (tr2, tr11, tr31), (tr3, tr21, tr11), (tr11, tr21, tr31))
    else:
        return split((tr1, tr31, tr21), ord-1) + split((tr2, tr11, tr31), ord-1) + split((tr3, tr21, tr11), ord-1) + split((tr11, tr21, tr31), ord-1)

eps=1e-10
def test (cubatur, ord):
    minorder = 100;
    maxmod = 0;
    mincord = (100, 0)
    for i in [0..ord]:
        for j in [0..ord]:
            locerr = error (x^i*y^j, cubatur, ttr)
            if (locerr > eps) & (i+j < minorder):
                minorder = i+j; mincord = (i, j); maxmod = locerr
            if (locerr > eps) & (i+j == minorder) & (locerr > maxmod):
                mincord = (i, j); maxmod = locerr
            print locerr, "&"
        print ("\\\\")
    print ("\n\n\n\n")
    P = x^mincord[0]*y^mincord[1]
    corrI = myI(P, ttr)
    print maxmod
    preveps = maxmod
    for i in [1..4]:
        curreps = abs(reduce (lambda u, v: u+v, map(lambda tr: S(P, cubatur, tr), split(ttr, i))) - corrI)
        print curreps/preveps, "&"
        preveps = curreps
︡92ff331d-cdbd-44b4-ba9a-9ab7cde7d104︡︡
︠a3809f6a-782c-498c-bcc5-9838529c3cb8︠
test([(0.666666666666666, 0.166666666666667, 0.166666666666667, 0.166666666666667)], 3)
︡d78a8475-dcac-4fc2-a0c4-a0d93d528748︡{"stdout": "9.99200722162641e-16 &\n6.66133814775094e-16 &\n3.33066907387547e-16 &\n0.000925925925925802 &\n\\\\\n3.33066907387547e-16 &\n1.66533453693773e-16 &\n0.000462962962962901 &\n0.00192901234567899 &\n\\\\\n5.55111512312578e-17 &\n0.000462962962962943 &\n0.000385802469135846 &\n0.00190145502645508 &\n\\\\\n0.000925925925925872 &\n0.000385802469135742 &\n0.000799162257495670 &\n0.00219693072702340 &\n\\\\\n\n\n\n\n\n0.000925925925925872\n3.37500000000014 &\n6.40653935185195 &\n0.711105810487330 &\n1.24322491897020 &"}︡
︠c386d62f-2b9c-45da-94ea-dcfa49163374︠
test([(0.736712498969535, 0.237932366475534, 0.025355134554931, 0.104166666666667), (1/3, 1/3, 1/3, 1/16)], 5)
︡0bac0aa3-d4e2-46df-968e-6d4663e587eb︡{"stdout": "9.99200722162641e-16 &\n7.21644966006352e-16 &\n3.00925950824649e-13 &\n6.60915766559356e-13 &\n1.04083408558608e-12 &\n0.000352733687494333 &\n\\\\\n3.60822483003176e-16 &\n1.50462975412324e-13 &\n3.30457883279678e-13 &\n5.20417042793042e-13 &\n0.000176366843747153 &\n0.000594650206666575 &\n\\\\\n3.00579006129453e-13 &\n2.70658495615805e-13 &\n3.20646287299553e-13 &\n0.0000352733690099569 &\n0.000176954733011055 &\n0.000438957476599000 &\n\\\\\n2.40751862889965e-13 &\n2.20760909552808e-13 &\n0.0000352733683586445 &\n0.0000318930038167090 &\n0.0000466392321854282 &\n0.000200914495170918 &\n\\\\\n2.00776895109556e-13 &\n0.000176366842846096 &\n0.000316872427779918 &\n0.000384087791258755 &\n0.000372382258523395 &\n0.000293228027552623 &\n\\\\\n0.000352733685892968 &\n0.000639917695310840 &\n0.000834019204218248 &\n0.000933516232088955 &\n0.000951582214241440 &\n0.000906437026621859 &\n\\\\\n\n\n\n\n\n0.000352733687494333\n338.554686129883 &\n0.640941574362544 &\n1.06482967125409 &\n0.873514756600137 &"}︡
